{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit KOLForm;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLRAS {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls, mckRAS,  mckObjs,  mckwidget {$ENDIF};
{$ELSE}
{$I uses.inc} mirror,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KP: TKOLProject;
    KF: TKOLForm;
    List: TKOLListBox;
    Tool: TKOLToolbar;
    RASMan: TKOLRAS;
    TI: TKOLTrayIcon;
    PM: TKOLPopupMenu;
    LB: TKOLLabel;
    PP: TKOLPopupMenu;
    procedure Dial;
    procedure HangUp;
    procedure ToolClick(Sender: PObj);
    procedure KFFormCreate(Sender: PObj);
    procedure ConnectingEvent(Sender: PRasObj; Msg, State: Integer; Error: Longint);
    procedure ListMouseDblClk(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure RASManError(Sender: PRASObj; Error: Integer);
    procedure L1Destroy(Sender: PObj);
    procedure KFClose(Sender: PObj; var Accept: Boolean);
    procedure L1MouseDown(Sender: PControl; var Mouse: TMouseEventData);
    function KFMessage(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure TIMouse(Sender: TObject; Message: Word);
    procedure PMMenuItem(Sender: PMenu; Item: Integer);
    procedure ListMouseUp(Sender: PControl; var Mouse: TMouseEventData);
    procedure ListDestroy(Sender: PObj);
    procedure PPN7Menu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
    redial: boolean;
    running: boolean;
  public
    { Public declarations }
  end;
var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

uses Ras;

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I KOLForm_1.inc}
{$ENDIF}

procedure TForm1.Dial;
begin
   RASMan.RASName := List.Items[List.CurIndex];
   RASMan.Connect;
   redial := true;
end;

procedure TForm1.HangUp;
var swap: boolean;
begin
   swap := false;
   if RASMan.Connected then begin
      swap := true;
   end;
   RASMan.DisConnect(true);
   redial := false;
   if swap then begin
      Tool.TBButtonEnabled[100] := True;
      Tool.TBButtonEnabled[101] := False;
   end;
end;

procedure TForm1.ToolClick(Sender: PObj);
begin
   If PControl(Sender).CurItem = 100 then begin
      Dial;
   end else
   if PControl(Sender).CurItem = 101 then begin
      HangUp;
   end else
   If PControl(Sender).CurItem = 102 then begin
      PostMessage(Form.Handle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
   end else
   if PControl(Sender).CurItem = 103 then begin
      Form.Close;
   end;
end;

procedure TForm1.KFFormCreate(Sender: PObj);
var p: PStrList;
    i: integer;
begin
   TI.Active := False;
   p := GetRASNames;
   for i := 0 to p.Count - 1 do
      List.Add(p.Items[i]);
   p.Free;
   Tool.TBButtonEnabled[100] := False;
   Tool.TBButtonEnabled[101] := False;
   running := true;
   for I := 0 to Tool.Count-1 do
      Tool.TBButtonWidth[i] := (Form.ClientWidth - 7) div Tool.Count;
end;

procedure TForm1.ConnectingEvent;
var s: string;
begin
   if running then begin
      LB.Text := RasMan.StatusString;
      S := RasMan.ErrorString;
      if S <> '' then begin
         LB.Text := S;
         LB.Color := clSilver;
         LB.Font.Color := clRed;
      end else begin
         LB.Color := clGray;
         LB.Font.Color := clWhite;
      end;
      Applet.Caption := '  ' + LB.Text;
      Tool.TBButtonEnabled[100] := State = 0;
      if Error <> 0 then begin
         Tool.TBButtonEnabled[100] := True;
         if Error = 608 then Redial := False;
         if Error = 615 then Redial := False;
         if Error = 633 then Redial := False;
         if Error = 797 then Redial := False;
      end;
      Tool.TBButtonEnabled[101] := not Tool.TBButtonEnabled[100];
      PM.ItemEnabled[0] := Tool.TBButtonEnabled[100];
      PM.ItemEnabled[1] := Tool.TBButtonEnabled[101];
   end;
   Sleep(600);
   if state = $2000 then begin
      PostMessage(Form.Handle, WM_SYSCOMMAND, SC_MINIMIZE, 0);
      Tool.TBButtonText[101] := 'Hangup';
      PM.ItemText[1] := 'Hangup';
   end;
   if state = $2001 then begin
      PostMessage(Form.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
      Tool.TBButtonText[101] := 'Cancel';
      PM.ItemText[1] := 'Cancel';
   end;
end;

procedure TForm1.ListMouseDblClk(Sender: PControl;
  var Mouse: TMouseEventData);
begin
   if redial = False then Dial;
end;

procedure TForm1.RASManError(Sender: PRASObj; Error: Integer);
begin
   RASMan.DisConnect(true);
   if error > 0 then beep(300, 200);
   if redial then begin
      RASMan.RASName := List.Items[List.CurIndex];
      RASMan.Connect;
   end;
end;

procedure TForm1.L1Destroy(Sender: PObj);
begin
   running := False;
end;

procedure TForm1.KFClose(Sender: PObj; var Accept: Boolean);
begin
   RasMan.DisConnect(True);
end;

procedure TForm1.L1MouseDown(Sender: PControl; var Mouse: TMouseEventData);
begin
  releasecapture;
  SendMessage(Form.Handle,wm_syscommand,$F012,0);
end;

function TForm1.KFMessage(var Msg: tagMSG; var Rslt: Integer): Boolean;
begin
   Result := False;
   if (Msg.message = WM_SYSCOMMAND) and
      (Msg.wParam = SC_MINIMIZE) then begin
      TI.Active := True;
      Applet.Visible := False;
      Form.Visible := False;
      Result := True;
      PM.ItemText[0] := 'Dial to ' + List.Items[List.CurIndex];
      PM.ItemEnabled[0] := Tool.TBButtonEnabled[100];
      if PM.ItemText[0] = 'Dial to ' then begin
         PM.ItemText[0] := 'Dial';
         PM.ItemEnabled[0] := False;
      end;
   end else
   if (Msg.message = WM_SYSCOMMAND) and
      (Msg.wParam = SC_RESTORE) then begin
      TI.Active := False;
      Applet.Visible := True;
      Form.Visible := True;
   end;
end;

procedure TForm1.TIMouse(Sender: TObject; Message: Word);
var P: TPoint;
begin
   if message = 512 then exit;
   if message = 513 then begin
      PostMessage(Form.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
   end;
   if message = 516 then begin
      GetCursorPos(P);
      PM.PopupEx(P.X,P.Y);
   end;
end;

procedure TForm1.PMMenuItem(Sender: PMenu; Item: Integer);
begin
   case Item of
  0:Dial;
  1:HangUp;
  2:PostMessage(Form.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
  3:Form.Close;
   end;
end;

procedure TForm1.ListMouseUp(Sender: PControl; var Mouse: TMouseEventData);
begin
   If List.CurIndex > -1 then begin
      if redial = False then Tool.TBButtonEnabled[100] := True;
   end;
end;

procedure TForm1.ListDestroy(Sender: PObj);
begin
   redial := False;
end;

procedure TForm1.PPN7Menu(Sender: PMenu; Item: Integer);
var h: integer;
begin
   if List.Count = 0 then exit;
   if RasEditPhonebookEntry(h, nil,
      PChar(List.Items[List.CurIndex])) <> 0 then
      ShowMessage('RasEditPhonebookEntry failed.');
end;

end.















